package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceComment_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceComment, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/comments");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void deleteComment(java.lang.String componentId, java.lang.String contentType, java.lang.String contentId, java.lang.String commentId, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.lang.String final_componentId = componentId;
    final java.lang.String final_contentType = contentType;
    final java.lang.String final_contentId = contentId;
    final java.lang.String final_commentId = commentId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(componentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(componentId))+"/"+(contentType== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentType))+"/"+(contentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentId))+"/"+(commentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(commentId))+"")
    .delete();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getAllComments(java.lang.String componentId, java.lang.String contentType, java.lang.String contentId, org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.comments.CommentDTO>> callback) {
    final java.lang.String final_componentId = componentId;
    final java.lang.String final_contentType = contentType;
    final java.lang.String final_contentId = contentId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(componentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(componentId))+"/"+(contentType== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentType))+"/"+(contentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentId))+"/")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.comments.CommentDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.comments.CommentDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.comments.CommentDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void saveNewComment(java.lang.String componentId, java.lang.String contentType, java.lang.String contentId, org.silverpeas.mobile.shared.dto.comments.CommentDTO commentToSave, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.comments.CommentDTO> callback) {
    final java.lang.String final_componentId = componentId;
    final java.lang.String final_contentType = contentType;
    final java.lang.String final_contentId = contentId;
    final org.silverpeas.mobile.shared.dto.comments.CommentDTO final_commentToSave = commentToSave;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(componentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(componentId))+"/"+(contentType== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentType))+"/"+(contentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentId))+"/")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    __method.json(org.silverpeas.mobile.shared.dto.comments.CommentDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(commentToSave));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.comments.CommentDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.comments.CommentDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.comments.CommentDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void updateComment(java.lang.String componentId, java.lang.String contentType, java.lang.String contentId, java.lang.String commentId, org.silverpeas.mobile.shared.dto.comments.CommentDTO comment, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.comments.CommentDTO> callback) {
    final java.lang.String final_componentId = componentId;
    final java.lang.String final_contentType = contentType;
    final java.lang.String final_contentId = contentId;
    final java.lang.String final_commentId = commentId;
    final org.silverpeas.mobile.shared.dto.comments.CommentDTO final_comment = comment;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(componentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(componentId))+"/"+(contentType== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentType))+"/"+(contentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(contentId))+"/"+(commentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(commentId))+"")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.comments.CommentDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(comment));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.comments.CommentDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.comments.CommentDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.comments.CommentDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
